Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 1932)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 1933)
@@ -980,15 +1003,15 @@
 
 !
-!--    Include couple arrays into client content
-!--    TO_DO: Klaus: better explain the above comment (what is client content?)
+!--    Include couple arrays into child content
+!--    TO_DO: Klaus: better explain the above comment (what is child content?)
        CALL  pmc_c_clear_next_array_list
        DO  WHILE ( pmc_c_getnextarray( myname ) )
-!--       TO_DO: Klaus, why the c-arrays are still up to cg%nz??
-          CALL pmci_create_client_arrays ( myname, icl, icr, jcs, jcn, cg%nz )
+!--       TO_DO: Klaus, why the child-arrays are still up to cg%nz??
+          CALL pmci_create_child_arrays ( myname, icl, icr, jcs, jcn, cg%nz )
        ENDDO
        CALL pmc_c_setind_and_allocmem
 
 !
-!--    Precompute interpolation coefficients and client-array indices
+!--    Precompute interpolation coefficients and child-array indices
        CALL pmci_init_interp_tril
 
@@ -1002,8 +1025,9 @@
 
 !
-!--    Two-way coupling.
+!--    Two-way coupling for general and vertical nesting.
 !--    Precompute the index arrays and relaxation functions for the
 !--    anterpolation
-       IF ( nesting_mode == 'two-way' )  THEN
+       IF ( TRIM( nesting_mode ) == 'two-way' .OR.                              &
+                  nesting_mode == 'vertical' )  THEN
           CALL pmci_init_anterp_tophat
        ENDIF
@@ -1097,5 +1121,5 @@
 !--    Note that MPI_Gather receives data from all processes in the rank order
 !--    TO_DO: refer to the line where this fact becomes important
-       CALL MPI_GATHER( coarse_bound, 5, MPI_INTEGER, coarse_bound_all, 5, &
+       CALL MPI_GATHER( coarse_bound, 5, MPI_INTEGER, coarse_bound_all, 5,      &
                         MPI_INTEGER, 0, comm2d, ierr )
 
@@ -1103,6 +1127,6 @@
           size_of_array(1) = SIZE( coarse_bound_all, 1 )
           size_of_array(2) = SIZE( coarse_bound_all, 2 )
-          CALL pmc_send_to_server( size_of_array, 2, 0, 40, ierr )
-          CALL pmc_send_to_server( coarse_bound_all, SIZE( coarse_bound_all ), &
+          CALL pmc_send_to_parent( size_of_array, 2, 0, 40, ierr )
+          CALL pmc_send_to_parent( coarse_bound_all, SIZE( coarse_bound_all ),  &
                                    0, 41, ierr )
        ENDIF
@@ -1114,5 +1138,5 @@
     SUBROUTINE pmci_init_interp_tril
 !
-!--    Precomputation of the interpolation coefficients and client-array indices
+!--    Precomputation of the interpolation coefficients and child-array indices
 !--    to be used by the interpolation routines interp_tril_lr, interp_tril_ns
 !--    and interp_tril_t.
@@ -1167,5 +1191,5 @@
 !
 !--    Note that the node coordinates xfs... and xcs... are relative to the
-!--    lower-left-bottom corner of the fc-array, not the actual client domain
+!--    lower-left-bottom corner of the fc-array, not the actual child domain
 !--    corner
        DO  i = nxlg, nxrg
@@ -1262,5 +1286,5 @@
           DO  i = nxl-1, nxl
              DO  j = nys, nyn
-                nzt_topo_nestbc_l = MAX( nzt_topo_nestbc_l, nzb_u_inner(j,i),  &
+                nzt_topo_nestbc_l = MAX( nzt_topo_nestbc_l, nzb_u_inner(j,i),   &
                                          nzb_v_inner(j,i), nzb_w_inner(j,i) )
              ENDDO
@@ -1273,5 +1297,5 @@
           i = nxr + 1
           DO  j = nys, nyn
-             nzt_topo_nestbc_r = MAX( nzt_topo_nestbc_r, nzb_u_inner(j,i),     &
+             nzt_topo_nestbc_r = MAX( nzt_topo_nestbc_r, nzb_u_inner(j,i),      &
                                       nzb_v_inner(j,i), nzb_w_inner(j,i) )
           ENDDO
@@ -1283,5 +1307,5 @@
           DO  j = nys-1, nys
              DO  i = nxl, nxr
-                nzt_topo_nestbc_s = MAX( nzt_topo_nestbc_s, nzb_u_inner(j,i),  &
+                nzt_topo_nestbc_s = MAX( nzt_topo_nestbc_s, nzb_u_inner(j,i),   &
                                          nzb_v_inner(j,i), nzb_w_inner(j,i) )
              ENDDO
@@ -1294,5 +1318,5 @@
           j = nyn + 1
           DO  i = nxl, nxr
-             nzt_topo_nestbc_n = MAX( nzt_topo_nestbc_n, nzb_u_inner(j,i),     &
+             nzt_topo_nestbc_n = MAX( nzt_topo_nestbc_n, nzb_u_inner(j,i),      &
                                       nzb_v_inner(j,i), nzb_w_inner(j,i) )
           ENDDO
@@ -1303,5 +1327,5 @@
 !--    Then determine the maximum number of near-wall nodes per wall point based
 !--    on the grid-spacing ratios.
-       nzt_topo_max = MAX( nzt_topo_nestbc_l, nzt_topo_nestbc_r,               &
+       nzt_topo_max = MAX( nzt_topo_nestbc_l, nzt_topo_nestbc_r,                &
                            nzt_topo_nestbc_s, nzt_topo_nestbc_n )
 
@@ -1343,5 +1367,5 @@
              k   = kb + 1
              wall_index = kb
-             CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j,     &
+             CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j,      &
                                 inc, wall_index, z0(j,i), kb, direction, ncorr )
              logc_u_l(1,k,j) = lc
@@ -1354,5 +1378,5 @@
              k   =  kb + 1
              wall_index = kb
-             CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j,     &
+             CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j,      &
                                 inc, wall_index, z0(j,i), kb, direction, ncorr )
              logc_v_l(1,k,j) = lc
@@ -1385,5 +1409,5 @@
              k   = kb + 1
              wall_index = kb
-             CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j,     &
+             CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j,      &
                                 inc, wall_index, z0(j,i), kb, direction, ncorr )
              logc_u_r(1,k,j) = lc
@@ -1396,5 +1420,5 @@
              k   = kb + 1
              wall_index = kb
-             CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j,     &
+             CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j,      &
                                 inc, wall_index, z0(j,i), kb, direction, ncorr )
              logc_v_r(1,k,j) = lc
@@ -1428,5 +1452,5 @@
              k   =  kb + 1
              wall_index = kb
-             CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j,     &
+             CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j,      &
                                 inc, wall_index, z0(j,i), kb, direction, ncorr )
              logc_u_s(1,k,i) = lc
@@ -1439,5 +1463,5 @@
              k   = kb + 1
              wall_index = kb
-             CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j,     &
+             CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j,      &
                                 inc, wall_index, z0(j,i), kb, direction, ncorr )
              logc_v_s(1,k,i) = lc
@@ -1471,5 +1495,5 @@
              k   = kb + 1
              wall_index = kb
-             CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j,     &
+             CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j,      &
                                 inc, wall_index, z0(j,i), kb, direction, ncorr )
              logc_u_n(1,k,i) = lc
@@ -1482,5 +1506,5 @@
              k   = kb + 1
              wall_index = kb
-             CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j,     &
+             CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j,      &
                                 inc, wall_index, z0(j,i), kb, direction, ncorr )
              logc_v_n(1,k,i) = lc
@@ -1502,5 +1526,5 @@
 
              ALLOCATE( logc_w_l(1:2,nzb:nzt_topo_nestbc_l,nys:nyn) )
-             ALLOCATE( logc_ratio_w_l(1:2,0:ncorr-1,nzb:nzt_topo_nestbc_l,     &
+             ALLOCATE( logc_ratio_w_l(1:2,0:ncorr-1,nzb:nzt_topo_nestbc_l,      &
                                       nys:nyn) )
 
@@ -1513,10 +1537,10 @@
 !--                Wall for u on the south side, but not on the north side
                    i  = 0
-                   IF ( ( nzb_u_outer(j,i) > nzb_u_outer(j+1,i) ) .AND.        &
-                        ( nzb_u_outer(j,i) == nzb_u_outer(j-1,i) ) )           &
+                   IF ( ( nzb_u_outer(j,i) > nzb_u_outer(j+1,i) ) .AND.         &
+                        ( nzb_u_outer(j,i) == nzb_u_outer(j-1,i) ) )            &
                    THEN
                       inc        =  1
                       wall_index =  j
-                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,   &
                           k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
 !
@@ -1531,9 +1555,9 @@
 !--                Wall for u on the north side, but not on the south side
                    i  = 0
-                   IF ( ( nzb_u_outer(j,i) > nzb_u_outer(j-1,i) ) .AND.        &
+                   IF ( ( nzb_u_outer(j,i) > nzb_u_outer(j-1,i) ) .AND.         &
                         ( nzb_u_outer(j,i) == nzb_u_outer(j+1,i) ) )  THEN
                       inc        = -1
                       wall_index =  j + 1
-                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,   &
                           k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
 !
@@ -1548,9 +1572,9 @@
 !--                Wall for w on the south side, but not on the north side.
                    i  = -1
-                   IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j+1,i) )  .AND.       &
+                   IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j+1,i) )  .AND.        &
                         ( nzb_w_outer(j,i) == nzb_w_outer(j-1,i) ) )  THEN
                       inc        =  1
                       wall_index =  j
-                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,   &
                           k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
 !
@@ -1565,9 +1589,9 @@
 !--                Wall for w on the north side, but not on the south side.
                    i  = -1
-                   IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j-1,i) )  .AND.       &
+                   IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j-1,i) )  .AND.        &
                         ( nzb_w_outer(j,i) == nzb_w_outer(j+1,i) ) )  THEN
                       inc        = -1
                       wall_index =  j+1
-                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,   &
                           k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
 !
@@ -1589,5 +1613,5 @@
 
              ALLOCATE( logc_w_r(1:2,nzb:nzt_topo_nestbc_r,nys:nyn) )
-             ALLOCATE( logc_ratio_w_r(1:2,0:ncorr-1,nzb:nzt_topo_nestbc_r,     &
+             ALLOCATE( logc_ratio_w_r(1:2,0:ncorr-1,nzb:nzt_topo_nestbc_r,      &
                                       nys:nyn) )
              logc_w_r       = 0
@@ -1600,9 +1624,9 @@
 !
 !--                Wall for u on the south side, but not on the north side
-                   IF ( ( nzb_u_outer(j,i) > nzb_u_outer(j+1,i) )  .AND.       &
+                   IF ( ( nzb_u_outer(j,i) > nzb_u_outer(j+1,i) )  .AND.        &
                         ( nzb_u_outer(j,i) == nzb_u_outer(j-1,i) ) )  THEN
                       inc        = 1
                       wall_index = j
-                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,   &
                           k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
 !
@@ -1616,9 +1640,9 @@
 !
 !--                Wall for u on the north side, but not on the south side
-                   IF ( ( nzb_u_outer(j,i) > nzb_u_outer(j-1,i) )  .AND.       &
+                   IF ( ( nzb_u_outer(j,i) > nzb_u_outer(j-1,i) )  .AND.        &
                         ( nzb_u_outer(j,i) == nzb_u_outer(j+1,i) ) )  THEN
                       inc        = -1
                       wall_index =  j+1
-                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,   &
                           k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
 !
@@ -1632,9 +1656,9 @@
 !
 !--                Wall for w on the south side, but not on the north side
-                   IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j+1,i) )  .AND.       &
+                   IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j+1,i) )  .AND.        &
                         ( nzb_w_outer(j,i) == nzb_w_outer(j-1,i) ) )  THEN
                       inc        =  1
                       wall_index =  j
-                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,   &
                           k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
 !
@@ -1648,9 +1672,9 @@
 !
 !--                Wall for w on the north side, but not on the south side
-                   IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j-1,i) )  .AND.       &
+                   IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j-1,i) )  .AND.        &
                         ( nzb_w_outer(j,i) == nzb_w_outer(j+1,i) ) )  THEN
                       inc        = -1
                       wall_index =  j+1
-                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,   &
                           k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
 
@@ -1673,5 +1697,5 @@
 
              ALLOCATE( logc_w_s(1:2,nzb:nzt_topo_nestbc_s,nxl:nxr) )
-             ALLOCATE( logc_ratio_w_s(1:2,0:ncorr-1,nzb:nzt_topo_nestbc_s,     &
+             ALLOCATE( logc_ratio_w_s(1:2,0:ncorr-1,nzb:nzt_topo_nestbc_s,      &
                                       nxl:nxr) )
              logc_w_s       = 0
@@ -1684,9 +1708,9 @@
 !--                Wall for v on the left side, but not on the right side
                    j  = 0
-                   IF ( ( nzb_v_outer(j,i) > nzb_v_outer(j,i+1) )  .AND.       &
+                   IF ( ( nzb_v_outer(j,i) > nzb_v_outer(j,i+1) )  .AND.        &
                         ( nzb_v_outer(j,i) == nzb_v_outer(j,i-1) ) )  THEN
                       inc        =  1
                       wall_index =  i
-                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,   &
                           k, i, inc, wall_index, z0(j,i), kb, direction, ncorr )
 !
@@ -1701,9 +1725,9 @@
 !--                Wall for v on the right side, but not on the left side
                    j  = 0
-                   IF ( ( nzb_v_outer(j,i) > nzb_v_outer(j,i-1) )  .AND.       &
+                   IF ( ( nzb_v_outer(j,i) > nzb_v_outer(j,i-1) )  .AND.        &
                         ( nzb_v_outer(j,i) == nzb_v_outer(j,i+1) ) )  THEN
                       inc        = -1
                       wall_index =  i+1
-                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,   &
                           k, i, inc, wall_index, z0(j,i), kb, direction, ncorr )
 !
@@ -1718,9 +1742,9 @@
 !--                Wall for w on the left side, but not on the right side
                    j  = -1
-                   IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j,i+1) )  .AND.       &
+                   IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j,i+1) )  .AND.        &
                         ( nzb_w_outer(j,i) == nzb_w_outer(j,i-1) ) )  THEN
                       inc        =  1
                       wall_index =  i
-                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,   &
                           k, i, inc, wall_index, z0(j,i), kb, direction, ncorr )
 !
@@ -1735,9 +1759,9 @@
 !--                Wall for w on the right side, but not on the left side
                    j  = -1
-                   IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j,i-1) )  .AND.       &
+                   IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j,i-1) )  .AND.        &
                         ( nzb_w_outer(j,i) == nzb_w_outer(j,i+1) ) )  THEN
                       inc        = -1
                       wall_index =  i+1
-                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,   &
                           k, i, inc, wall_index, z0(j,i), kb, direction, ncorr )
 !
@@ -1759,5 +1783,5 @@
 
              ALLOCATE( logc_w_n(1:2,nzb:nzt_topo_nestbc_n, nxl:nxr) )
-             ALLOCATE( logc_ratio_w_n(1:2,0:ncorr-1,nzb:nzt_topo_nestbc_n,     &
+             ALLOCATE( logc_ratio_w_n(1:2,0:ncorr-1,nzb:nzt_topo_nestbc_n,      &
                                       nxl:nxr) )
              logc_w_n       = 0
@@ -1770,9 +1794,9 @@
 !
 !--                Wall for v on the left side, but not on the right side
-                   IF ( ( nzb_v_outer(j,i) > nzb_v_outer(j,i+1) )  .AND.       &
+                   IF ( ( nzb_v_outer(j,i) > nzb_v_outer(j,i+1) )  .AND.        &
                         ( nzb_v_outer(j,i) == nzb_v_outer(j,i-1) ) )  THEN
                       inc        = 1
                       wall_index = i
-                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,   &
                           k, i, inc, wall_index, z0(j,i), kb, direction, ncorr )
 !
@@ -1786,9 +1810,9 @@
 !
 !--                Wall for v on the right side, but not on the left side
-                   IF ( ( nzb_v_outer(j,i) > nzb_v_outer(j,i-1) )  .AND.       &
+                   IF ( ( nzb_v_outer(j,i) > nzb_v_outer(j,i-1) )  .AND.        &
                         ( nzb_v_outer(j,i) == nzb_v_outer(j,i+1) ) )  THEN
                       inc        = -1
                       wall_index =  i + 1
-                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,   &
                           k, i, inc, wall_index, z0(j,i), kb, direction, ncorr )
 !
@@ -1802,9 +1826,9 @@
 !
 !--                Wall for w on the left side, but not on the right side
-                   IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j,i+1) )  .AND.       &
+                   IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j,i+1) )  .AND.        &
                         ( nzb_w_outer(j,i) == nzb_w_outer(j,i-1) ) )  THEN
                       inc        = 1
                       wall_index = i
-                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,   &
                           k, i, inc, wall_index, z0(j,i), kb, direction, ncorr )
 !
@@ -1818,9 +1842,9 @@
 !
 !--                Wall for w on the right side, but not on the left side
-                   IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j,i-1) )  .AND.       &
+                   IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j,i-1) )  .AND.        &
                         ( nzb_w_outer(j,i) == nzb_w_outer(j,i+1) ) )  THEN
                       inc        = -1
                       wall_index =  i+1
-                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,   &
                           k, i, inc, wall_index, z0(j,i), kb, direction, ncorr )
 !
@@ -1843,5 +1867,5 @@
 
 
-    SUBROUTINE pmci_define_loglaw_correction_parameters( lc, lcr, k, ij, inc,  &
+    SUBROUTINE pmci_define_loglaw_correction_parameters( lc, lcr, k, ij, inc,   &
                                         wall_index, z0_l, kb, direction, ncorr )
 
@@ -1897,5 +1921,5 @@
                 corr_index = ij + lcorr   ! In this case (direction = 2) ij is j
                 IF ( lcorr == 0 )  THEN
-                   CALL pmci_find_logc_pivot_j( lc, logvelc1, ij, wall_index,  &
+                   CALL pmci_find_logc_pivot_j( lc, logvelc1, ij, wall_index,   &
                                                 z0_l, inc )
                 ENDIF
@@ -1905,6 +1929,6 @@
 !--             valid in both directions
                 IF ( inc * corr_index < inc * lc )  THEN
-                   lcr(alcorr) = LOG( ABS( coord_y(corr_index) + 0.5_wp * dy   &
-                                         - coord_y(wall_index) ) / z0_l )      &
+                   lcr(alcorr) = LOG( ABS( coord_y(corr_index) + 0.5_wp * dy    &
+                                         - coord_y(wall_index) ) / z0_l )       &
                                  / logvelc1
                    more = .TRUE.
@@ -1924,5 +1948,5 @@
                 corr_index = ij + lcorr   ! In this case (direction = 3) ij is i
                 IF ( lcorr == 0 )  THEN
-                   CALL pmci_find_logc_pivot_i( lc, logvelc1, ij, wall_index,  &
+                   CALL pmci_find_logc_pivot_i( lc, logvelc1, ij, wall_index,   &
                                                 z0_l, inc )
                 ENDIF
@@ -1931,6 +1955,6 @@
 !--             valid in both directions
                 IF ( inc * corr_index < inc * lc )  THEN
-                   lcr(alcorr) = LOG( ABS( coord_x(corr_index) + 0.5_wp * dx   &
-                                         - coord_x(wall_index) ) / z0_l )      &
+                   lcr(alcorr) = LOG( ABS( coord_x(corr_index) + 0.5_wp * dx    &
+                                         - coord_x(wall_index) ) / z0_l )       &
                                  / logvelc1
                    more = .TRUE.
@@ -1963,5 +1987,5 @@
        INTEGER(iwp) ::  k1     !:
 
-       REAL(wp),INTENT(OUT) ::  logzc1     !:
+       REAL(wp), INTENT(OUT) ::  logzc1     !:
        REAL(wp), INTENT(IN) ::  z0_l       !:
 
@@ -2072,5 +2096,5 @@
     SUBROUTINE pmci_init_anterp_tophat
 !
-!--    Precomputation of the client-array indices for
+!--    Precomputation of the child-array indices for
 !--    corresponding coarse-grid array index and the
 !--    Under-relaxation coefficients to be used by anterp_tophat.
@@ -2148,10 +2172,10 @@
        DO  ii = icl, icr
           i = istart
-          DO  WHILE ( ( coord_x(i) < cg%coord_x(ii) - 0.5_wp * cg%dx )  .AND.  &
+          DO  WHILE ( ( coord_x(i) < cg%coord_x(ii) - 0.5_wp * cg%dx )  .AND.   &
                       ( i < nxrg ) )
              i = i + 1
           ENDDO
           iflu(ii) = MIN( MAX( i, nxlg ), nxrg )
-          DO  WHILE ( ( coord_x(i) < cg%coord_x(ii) + 0.5_wp * cg%dx )  .AND.  &
+          DO  WHILE ( ( coord_x(i) < cg%coord_x(ii) + 0.5_wp * cg%dx )  .AND.   &
                       ( i < nxrg ) )
              i = i + 1
@@ -2166,10 +2190,10 @@
        DO  ii = icl, icr
           i = istart
-          DO  WHILE ( ( coord_x(i) + 0.5_wp * dx < cg%coord_x(ii) )  .AND.     &
+          DO  WHILE ( ( coord_x(i) + 0.5_wp * dx < cg%coord_x(ii) )  .AND.      &
                       ( i < nxrg ) )
              i = i + 1
           ENDDO
           iflo(ii) = MIN( MAX( i, nxlg ), nxrg )
-          DO  WHILE ( ( coord_x(i) + 0.5_wp * dx < cg%coord_x(ii) + cg%dx )    &
+          DO  WHILE ( ( coord_x(i) + 0.5_wp * dx < cg%coord_x(ii) + cg%dx )     &
                       .AND.  ( i < nxrg ) )
              i = i + 1
@@ -2184,10 +2208,10 @@
        DO  jj = jcs, jcn
           j = jstart
-          DO  WHILE ( ( coord_y(j) < cg%coord_y(jj) - 0.5_wp * cg%dy )  .AND.  &
+          DO  WHILE ( ( coord_y(j) < cg%coord_y(jj) - 0.5_wp * cg%dy )  .AND.   &
                       ( j < nyng ) )
              j = j + 1
           ENDDO
           jflv(jj) = MIN( MAX( j, nysg ), nyng )
-          DO  WHILE ( ( coord_y(j) < cg%coord_y(jj) + 0.5_wp * cg%dy )  .AND.  &
+          DO  WHILE ( ( coord_y(j) < cg%coord_y(jj) + 0.5_wp * cg%dy )  .AND.   &
                       ( j < nyng ) )
              j = j + 1
@@ -2202,10 +2226,10 @@
        DO  jj = jcs, jcn
           j = jstart
-          DO  WHILE ( ( coord_y(j) + 0.5_wp * dy < cg%coord_y(jj) )  .AND.     &
+          DO  WHILE ( ( coord_y(j) + 0.5_wp * dy < cg%coord_y(jj) )  .AND.      &
                       ( j < nyng ) )
              j = j + 1
           ENDDO
           jflo(jj) = MIN( MAX( j, nysg ), nyng )
-          DO  WHILE ( ( coord_y(j) + 0.5_wp * dy < cg%coord_y(jj) + cg%dy )    &
+          DO  WHILE ( ( coord_y(j) + 0.5_wp * dy < cg%coord_y(jj) + cg%dy )     &
                       .AND.  ( j < nyng ) )
              j = j + 1
@@ -2222,10 +2246,10 @@
        DO  kk = 1, kctw
           k = kstart
-          DO  WHILE ( ( zw(k) < cg%zw(kk) - 0.5_wp * cg%dzw(kk) )  .AND.       &
+          DO  WHILE ( ( zw(k) < cg%zw(kk) - 0.5_wp * cg%dzw(kk) )  .AND.        &
                       ( k < nzt ) )
              k = k + 1
           ENDDO
           kflw(kk) = MIN( MAX( k, 1 ), nzt + 1 )
-          DO  WHILE ( ( zw(k) < cg%zw(kk) + 0.5_wp * cg%dzw(kk+1) )  .AND.     &
+          DO  WHILE ( ( zw(k) < cg%zw(kk) + 0.5_wp * cg%dzw(kk+1) )  .AND.      &
                       ( k < nzt ) )
              k = k + 1
@@ -2242,10 +2266,10 @@
        DO  kk = 1, kctu
           k = kstart
-          DO  WHILE ( ( zu(k) < cg%zu(kk) - 0.5_wp * cg%dzu(kk) )  .AND.       &
+          DO  WHILE ( ( zu(k) < cg%zu(kk) - 0.5_wp * cg%dzu(kk) )  .AND.        &
                       ( k < nzt ) )
              k = k + 1
           ENDDO
           kflo(kk) = MIN( MAX( k, 1 ), nzt + 1 )
-          DO  WHILE ( ( zu(k) < cg%zu(kk) + 0.5_wp * cg%dzu(kk+1) )  .AND.     &
+          DO  WHILE ( ( zu(k) < cg%zu(kk) + 0.5_wp * cg%dzu(kk+1) )  .AND.      &
                       ( k < nzt ) )
              k = k + 1
@@ -2272,34 +2296,39 @@
 !--    Spatial under-relaxation coefficients
        ALLOCATE( frax(icl:icr) )
-
-       DO  ii = icl, icr
-          IF ( nest_bound_l )  THEN
-             xi = ( MAX( 0.0_wp, ( cg%coord_x(ii) - lower_left_coord_x ) ) /   &
-                    anterp_relax_length_l )**4
-          ELSEIF ( nest_bound_r )  THEN
-             xi = ( MAX( 0.0_wp, ( lower_left_coord_x + ( nx + 1 ) * dx -      &
-                                   cg%coord_x(ii) ) ) /                        &
-                    anterp_relax_length_r )**4
-          ELSE
-             xi = 999999.9_wp
-          ENDIF
-          frax(ii) = xi / ( 1.0_wp + xi )
-       ENDDO
-
        ALLOCATE( fray(jcs:jcn) )
-
-       DO  jj = jcs, jcn
-          IF ( nest_bound_s )  THEN
-             eta = ( MAX( 0.0_wp, ( cg%coord_y(jj) - lower_left_coord_y ) ) /  &
-                     anterp_relax_length_s )**4
-          ELSEIF ( nest_bound_n )  THEN
-             eta = ( MAX( 0.0_wp, ( lower_left_coord_y + ( ny + 1 ) * dy -     &
-                                    cg%coord_y(jj)) ) /                        &
-                     anterp_relax_length_n )**4
-          ELSE
-             eta = 999999.9_wp
-          ENDIF
-          fray(jj) = eta / ( 1.0_wp + eta )
-       ENDDO
+       
+       frax(icl:icr) = 1.0_wp
+       fray(jcs:jcn) = 1.0_wp
+
+       IF ( nesting_mode /= 'vertical' )  THEN
+          DO  ii = icl, icr
+             IF ( nest_bound_l )  THEN
+                xi = ( MAX( 0.0_wp, ( cg%coord_x(ii) -                          &
+                       lower_left_coord_x ) ) / anterp_relax_length_l )**4
+             ELSEIF ( nest_bound_r )  THEN
+                xi = ( MAX( 0.0_wp, ( lower_left_coord_x + ( nx + 1 ) * dx -    &
+                                      cg%coord_x(ii) ) ) /                      &
+                       anterp_relax_length_r )**4
+             ELSE
+                xi = 999999.9_wp
+             ENDIF
+             frax(ii) = xi / ( 1.0_wp + xi )
+          ENDDO
+
+
+          DO  jj = jcs, jcn
+             IF ( nest_bound_s )  THEN
+                eta = ( MAX( 0.0_wp, ( cg%coord_y(jj) -                         &
+                        lower_left_coord_y ) ) / anterp_relax_length_s )**4
+             ELSEIF ( nest_bound_n )  THEN
+                eta = ( MAX( 0.0_wp, ( lower_left_coord_y + ( ny + 1 ) * dy -   &
+                                       cg%coord_y(jj)) ) /                      &
+                        anterp_relax_length_n )**4
+             ELSE
+                eta = 999999.9_wp
+             ENDIF
+             fray(jj) = eta / ( 1.0_wp + eta )
+          ENDDO
+       ENDIF
       
        ALLOCATE( fraz(0:kctu) )
@@ -2347,5 +2376,5 @@
                 height = zu(k) - zu(nzb_s_inner(j,i))
                 fw     = EXP( -cfw * height / glsf )
-                tkefactor_l(k,j) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *     &
+                tkefactor_l(k,j) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *      &
                                               ( glsf / glsc )**p23 )
              ENDDO
@@ -2365,5 +2394,5 @@
                 height = zu(k) - zu(nzb_s_inner(j,i))
                 fw     = EXP( -cfw * height / glsf )
-                tkefactor_r(k,j) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *     &
+                tkefactor_r(k,j) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *      &
                                               ( glsf / glsc )**p23 )
              ENDDO
@@ -2383,5 +2412,5 @@
                 height = zu(k) - zu(nzb_s_inner(j,i))
                 fw     = EXP( -cfw*height / glsf )
-                tkefactor_s(k,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *     &
+                tkefactor_s(k,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *      &
                                               ( glsf / glsc )**p23 )
              ENDDO
@@ -2401,5 +2430,5 @@
                 height = zu(k) - zu(nzb_s_inner(j,i))
                 fw     = EXP( -cfw * height / glsf )
-                tkefactor_n(k,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *     &
+                tkefactor_n(k,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *      &
                                               ( glsf / glsc )**p23 )
              ENDDO
@@ -2417,5 +2446,5 @@
              height = zu(k) - zu(nzb_s_inner(j,i))
              fw     = EXP( -cfw * height / glsf )
-             tkefactor_t(j,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *        &
+             tkefactor_t(j,i) = c_tkef * ( fw0 * fw + ( 1.0_wp - fw ) *         &
                                            ( glsf / glsc )**p23 )
           ENDDO
@@ -2425,5 +2454,5 @@
 
 #endif
- END SUBROUTINE pmci_setup_client
+ END SUBROUTINE pmci_setup_child
 
 
@@ -2456,9 +2485,9 @@
 
 
- SUBROUTINE pmci_set_array_pointer( name, client_id, nz_cl )
+ SUBROUTINE pmci_set_array_pointer( name, child_id, nz_cl )
 
     IMPLICIT NONE
 
-    INTEGER, INTENT(IN)          ::  client_id   !:
+    INTEGER, INTENT(IN)          ::  child_id    !:
     INTEGER, INTENT(IN)          ::  nz_cl       !:
     CHARACTER(LEN=*), INTENT(IN) ::  name        !:
@@ -2493,7 +2522,7 @@
 #if defined( __nopointer )
     IF ( ASSOCIATED( p_3d ) )  THEN
-       CALL pmc_s_set_dataarray( client_id, p_3d, nz_cl, nz )
+       CALL pmc_s_set_dataarray( child_id, p_3d, nz_cl, nz )
     ELSEIF ( ASSOCIATED( p_2d ) )  THEN
-       CALL pmc_s_set_dataarray( client_id, p_2d )
+       CALL pmc_s_set_dataarray( child_id, p_2d )
     ELSE
 !
